﻿<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>Google Maps API by Vue.js</title>
    <style>
        #map {
            height: 600px; 
            width:100%;
        }
        html, body {
            height:100%;
            margin:0;
            padding:0;
        }
       
    </style>
    <link href="css/style.css" rel="stylesheet" />
    <script src="https://cdn.jsdelivr.net/npm/vue@2.6.10/dist/vue.js"></script>
</head>
<body>

    <div class="content" id="app">

        <div class="box box-solid bg-teal-gradient">
            <div class="box-header">
                <div class="col-md-4">
                    <div class="input-group">
                        <input type="text" v-model="txt_search" v-on:keyup.13="onSearch" class="form-control">
                        <div class="input-group-btn">
                            <button type="button" class="btn btn-info" @click="onSearch"><i class="fa fa-search"></i></button>
                        </div>

                    </div>
                </div>
            </div>
            <div class="box-body">
                <div id="map"></div>
            </div>
        </div>

        <div class="box">
            <div class="box-header">
                <h3 class="box-title">Data Restaurant [API Resful].</h3>
            </div>
            <div>
                <div class="box-body table-responsive no-padding">
                    <!--<template></template>-->
                    <table class="table table-hover">
                        <tr>
                            <th style="width: 20px">#</th>
                            <th>ชื่อ</th>
                            <th>ที่อยู่</th>
                            <th style="width: 40px"></th>
                        </tr>
                        <tr v-for="Restaurant, i in Restaurants">
                            <td>{{Restaurant.Id}}.</td>
                            <td>{{Restaurant.Name}}</td>
                            <td>{{Restaurant.Description}}</td>
                            <td>
                                <button type="button" class="btn btn-block btn-info btn-xs" v-on:click="onClickRestaurant(Restaurant)">Click</button>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>

        </div>

    </div>

    <script>
        var position = { lat: 13.8170403, lng: 100.5200337 };//บางซื่อ
        new Vue({
            el: '#app',
            data() {
                return {
                    Restaurants: null,
                    txt_search:'บางซื่อ'
                }
            },
            methods: {
                onLoad: async function (data) {
                    console.log("OnLoad()");

                    var maps = new google.maps.Map(document.getElementById('map'), {
                        center: position,
                        zoom: 14
                    });

                    for (var i = 0; i < data.length; i++) {

                        marker = new google.maps.Marker({
                            animation: google.maps.Animation.DROP,
                            position: new google.maps.LatLng(data[i].Lat, data[i].Lng),
                            title: data[i].Name,
                            map: maps,

                        });
                        google.maps.event.addListener(marker, 'click', (function (marker, i) {
                            return function () {

                                if (marker.getAnimation() !== null) {
                                    marker.setAnimation(null);
                                } else {
                                    marker.setAnimation(google.maps.Animation.BOUNCE)
                                }
                            }

                        })(marker, i));

                    }

                },
                onClickRestaurant: async function (Restaurant) {

                    var maps = new google.maps.Map(document.getElementById('map'), {
                        center: { lat: Restaurant.Lat, lng: Restaurant.Lng },
                        zoom: 14
                    });

                    var marker = new google.maps.Marker({
                        position: new google.maps.LatLng(Restaurant.Lat, Restaurant.Lng),
                        title: Restaurant.Name,
                        map: maps,
                    });

                    marker.setAnimation(google.maps.Animation.BOUNCE);

                },
                onSearch: async function () {

                    var input = this.txt_search;

                    console.log(input);
                    console.log('onSearch');

                    var resultsMap = new google.maps.Map(document.getElementById('map'), {
                        zoom: 14,
                        center: position,
                    });
                    var geocoder = new google.maps.Geocoder();

                    geocoder.geocode({ 'address': input }, function (results, status) {
                        if (status === 'OK') {
                            resultsMap.setCenter(results[0].geometry.location);
                            new google.maps.Marker({
                                map: resultsMap,
                                position: results[0].geometry.location
                            });
                        } else {
                            alert('Geocode was not succressful for the following reason : ' + status);
                        }


                    });

                }
            },
            mounted() {
                fetch("http://localhost:53157/api/Restaurant")//connect Web api rest ful
                    .then(response => response.json())
                    .then((data) => {

                        this.Restaurants = data;
                        this.onLoad(data);
                    })

            }



        });
        function initMap() { }
    </script>

    <script async defer src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAgdV8mWpYkESsFNWOAvp6vt1ju_9mYL9o&callback=initMap" type="text/javascript"></script>
    <link href="components/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet" />
    <link href="components/font-awesome/css/font-awesome.css" rel="stylesheet" />
</body>

</html>